-- __________ Busy and Away by Niketa-Moonrunner (US) / http://niketa.net / addons@niketa.net __________ --

SLASH_BUSYANDAWAY1 = "/baa"

function SlashCmdList.BUSYANDAWAY(msg, editbox)
	local cmd, arg = msg:match("^(%S*)%s*(.-)$")
	
	if cmd == "flag" then
		if arg == "1" then
			BAA_FLAGTYPE = 1
			print("|cffffff00Busy and Away:|r You've set your flag preference to 1. Your DND messages will be restored after you come back from AFK.")
		elseif arg == "2" then
			BAA_FLAGTYPE = 2
			print("|cffffff00Busy and Away:|r You've set your flag preference to 2. Your DND messages will be restored as soon as you're flagged AFK.")
		elseif arg == "" then
			local desc
			if BAA_FLAGTYPE == 1 then
				desc = "Your DND messages will be restored after you come back from AFK."
			elseif BAA_FLAGTYPE == 2 then
				desc = "Your DND messages will be restored as soon as you're flagged AFK."
			end
			print("|cffffff00Busy and Away:|r Your current flag preference is "..BAA_FLAGTYPE..". "..desc)
		else
			print("|cffffff00Busy and Away:|r The flag type you've entered is in the wrong format. To restore your DND message after coming back from AFK use the command \"/baa flag 1\". To restore your DND message as soon as you're flagged AFK use the command \"/baa flag 2\".")
		end
	elseif cmd == "clear" then
		BAA_DNDMSG = nil
	else
		print("|cffffff00Busy and Away")
		print("To manually clear your DND message, use the command \"/baa clear\".")
		print("To check your current flag preference, use the command \"/baa flag\".")
		print("Preferences: To restore your DND messages after coming back from AFK, use the command \"/baa flag 1\".")
		print("Preferences: To restore your DND messages as soon as you're flagged AFK, use the command \"/baa flag 2\".")
	end
end

local f = CreateFrame("Frame")

f:RegisterEvent("ADDON_LOADED")
f:RegisterEvent("PLAYER_ENTERING_WORLD")
f:RegisterEvent("CHAT_MSG_SYSTEM")
f:RegisterEvent("PLAYER_FLAGS_CHANGED")

local flag

f:SetScript("OnEvent", function(self, event, ...)
	if event == "ADDON_LOADED" then
		local addon = ...
		if addon == "Busy and Away" then
			print("|cffffff00Busy and Away:|r Use the command \"/baa\" for help and to set your preferences.")
			
			local desc
			
			if not BAA_FLAGTYPE then
				BAA_FLAGTYPE = 1
			elseif BAA_FLAGTYPE == 1 then
				desc = "Your DND messages will be restored after you come back from AFK."
				print("|cffffff00Busy and Away:|r Your current flag preference is "..BAA_FLAGTYPE..". "..desc)
			elseif BAA_FLAGTYPE == 2 then
				desc = "Your DND messages will be restored as soon as you're flagged AFK."
				print("|cffffff00Busy and Away:|r Your current flag preference is "..BAA_FLAGTYPE..". "..desc)
			end
		end
	elseif event == "PLAYER_ENTERING_WORLD" then
		if not UnitIsDND("player") and BAA_DNDMSG then
			BAA_DNDMSG = nil
		end
	elseif event == "CHAT_MSG_SYSTEM" then
		local msg = ...
		
		if msg:find("You are now Busy:") then
			BAA_DNDMSG = msg:match(":%s(.*)")
		end
	elseif event == "PLAYER_FLAGS_CHANGED" then
		if UnitIsAFK("player") and BAA_DNDMSG and BAA_FLAGTYPE == 2 then
			ChatFrame1EditBox:SetText("/busy "..BAA_DNDMSG)
			ChatEdit_SendText(ChatFrame1EditBox)
		elseif UnitIsAFK("player") and BAA_DNDMSG and BAA_FLAGTYPE == 1 then
			flag = true
		elseif not UnitIsAFK("player") and not UnitIsDND("player") and BAA_DNDMSG then
			if BAA_FLAGTYPE == 1 and flag then
				ChatFrame1EditBox:SetText("/busy "..BAA_DNDMSG)
				ChatEdit_SendText(ChatFrame1EditBox)
				flag = nil
			else
				BAA_DNDMSG = nil
			end
		end
	end
end)